// AlternativeElx.h: interface for the CAlternativeElx class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/28 09:27:02
//

#ifndef AFX_ALTERNATIVEELX_H__
#define AFX_ALTERNATIVEELX_H__

#include "SerialNoElx.h"
#include <list>

typedef std::list <ElxInterface *> elxlist;
typedef elxlist::iterator          elxiter;

//
// Alternative
//
class CAlternativeElx : public CSerialNoElx  
{
public:
	int Match    (ContextInterface * pContext);
	int MatchNext(ContextInterface * pContext);

public:
	CAlternativeElx & AppendElx(ElxInterface * pElx);

protected:
	elxlist m_lstElxs;
};

#endif//AFX_ALTERNATIVEELX_H__
