// DelegateElx.h : 
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#ifndef _DELEGATE_ELX_H_
#define _DELEGATE_ELX_H_

#include "ElxInterface.h"

//
// Delegate
//
class CDelegateElx : public ElxInterface
{
public:
	int Match    (ContextInterface * pContext);
	int MatchNext(ContextInterface * pContext);

public:
	CDelegateElx(ElxInterface * pElx = 0, ElxInterface * pNext = 0, unsigned int nParam1 = 0, unsigned int nParam2 = 0);
	void SetElxs(ElxInterface * pElx = 0, ElxInterface * pNext = 0, unsigned int nParam1 = 0, unsigned int nParam2 = 0);

	inline unsigned int GetParam1() { return m_nParam1; }
	inline unsigned int GetParam2() { return m_nParam2; }

protected:
	ElxInterface * m_pElx, * m_pNext;
	unsigned int m_nParam1, m_nParam2;
};

#endif//_DELEGATE_ELX_H_
