// ListElx.cpp: implementation of the CListElx class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#include "ListElx.h"

CListElx::CListElx()
{
}

CListElx & CListElx::InsertElx(ElxInterface * pElx)
{
	// insert
	if(pElx != 0)
		m_lstElxs.insert(m_lstElxs.begin(), pElx);

	return *this;
}

CListElx & CListElx::AppendElx(ElxInterface * pElx)
{
	// insert
	if(pElx != 0)
		m_lstElxs.insert(m_lstElxs.end(), pElx);

	return *this;
}

int CListElx::Match(ContextInterface * pContext)
{
	// check empty
	if(m_lstElxs.empty())
		return 1;

	return MatchFrom(pContext, m_lstElxs.begin());
}

int CListElx::MatchNext(ContextInterface * pContext)
{
	if(m_lstElxs.empty())
		return 0;

	// get end
	elxiter ppelx = m_lstElxs.end();

	// from end to begin
	while(1)
	{
		ppelx--;

		if((*ppelx)->MatchNext(pContext))
		{
			ppelx++;
			break;
		}

		if(ppelx == m_lstElxs.begin())
			return 0;
	}

	return MatchFrom(pContext, ppelx);
}

int CListElx::MatchFrom(ContextInterface * pContext, elxiter ppelx)
{
	// check end
	if(m_lstElxs.end() == ppelx)
		return 1;

	while(1)
	{
		if((*ppelx)->Match(pContext))
		{
			ppelx++;
			if(ppelx == m_lstElxs.end())
				return 1;
		}
		else
		{
			while(ppelx != m_lstElxs.begin())
			{
				ppelx--;
				if((*ppelx)->MatchNext(pContext))
				{
					ppelx++;
					break;
				}
			}

			if(ppelx == m_lstElxs.begin())
				return 0;
		}
	}
}
