// ListElx.h: interface for the CListElx class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#ifndef AFX_LISTELX_H__
#define AFX_LISTELX_H__

#include "ElxInterface.h"
#include <list>

typedef std::list <ElxInterface *> elxlist;
typedef elxlist::iterator          elxiter;

//
// List
//
class CListElx : public ElxInterface  
{
public:
	int Match    (ContextInterface * pContext);
	int MatchNext(ContextInterface * pContext);

public:
	CListElx();
	CListElx & InsertElx(ElxInterface * pElx);
	CListElx & AppendElx(ElxInterface * pElx);

protected:
	int MatchFrom(ContextInterface * pContext, elxiter ppelx);

	elxlist m_lstElxs;
};

#endif//AFX_LISTELX_H__
