// StackInterface.h : Interface of stack
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#ifndef _STACK_INTERFACE_H_
#define _STACK_INTERFACE_H_

struct StackState
{
	int nSize;
	unsigned int nId;
};

class StackInterface
{
public:
	virtual void Push(unsigned int   n, unsigned int id = 0) = 0;
	virtual int  Pop (unsigned int & n, unsigned int id = 0) = 0;
	virtual int  Peek(unsigned int & n, unsigned int id = 0) = 0;

	virtual void Mark   (StackState & state) = 0;
	virtual void Restore(StackState   state) = 0;

public:
	virtual     ~StackInterface(){};
};

#endif//_STACK_INTERFACE_H_
