// AssertElx.cpp: implementation of the CAssertElx class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#include "AssertElx.h"

CAssertElx::CAssertElx(ElxInterface * pElx, int bYes)
{
	m_pElx = pElx;
	m_bYes = bYes;
}

int CAssertElx::Match(ContextInterface * pContext)
{
	// state
	ContextState state;
	int succ;

	pContext->Mark(state);

	// match
	if(m_bYes)
		succ =   m_pElx->Match(pContext);
	else
		succ = ! m_pElx->Match(pContext);

	pContext->Restore(state);

	return succ;
}
