// BackrefElx.cpp: implementation of the CBackrefElx class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#include "BackrefElx.h"

CBackrefElx::CBackrefElx(int nbackref, int nType, int bNoPush)
{
	m_nbackref = nbackref;
	m_nType    = nType;
	m_bNoPush  = bNoPush;
}

int CBackrefElx::Match(ContextInterface * pContext)
{
	if(m_nType == 0)
		pContext->PushBackrefStart(m_nbackref, pContext->GetCurrentPos(), m_bNoPush);
	else
		pContext->PushBackrefEnd(m_nbackref, pContext->GetCurrentPos());

	return 1;
}

int CBackrefElx::MatchNext(ContextInterface * pContext)
{
	if(m_nType == 0)
		pContext->PopBackrefStart(m_nbackref);
	else
		pContext->PopBackrefEnd(m_nbackref);

	return 0;
}
