// ElxBuilderInterface.h
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#ifndef _ELX_BUILDER_INTERFACE_H_
#define _ELX_BUILDER_INTERFACE_H_

#include "ElxInterface.h"
#include "StringRef.h"

template <typename CHART> class ElxBuilderInterfaceT
{
public:
	virtual ElxInterface * Build(const StringRefT <CHART> & pattern, int flags = 0) = 0;
	virtual void Clear() = 0;
};

#endif//_ELX_BUILDER_INTERFACE_H_
